﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace _TEST_TP1
{
    class Voteur
    {
        public static Capteur Voter(Capteur cp1, Capteur cp2, Capteur cp3)
        {

            //si les trois capteurs sont valides
            if (cp1.IsValid && cp2.IsValid && cp3.IsValid)
            {
                if (cp1.EstCoherant() && cp2.EstCoherant() && cp3.EstCoherant())
                {
                    Int32 somme = (cp1.Valeur + cp2.Valeur + cp3.Valeur);
                    int moyenne =  somme / 3;
                    return new Capteur(moyenne, true);
                }
            }
            //si deux capteurs sont valides
            if (cp1.IsValid && cp2.IsValid && !cp3.IsValid)
            {
                return Coherance2(cp1, cp2);
            }

            if (cp1.IsValid && !cp2.IsValid && cp3.IsValid)
            {
                return Coherance2(cp1, cp3);
            }

            if (!cp1.IsValid && cp2.IsValid && cp3.IsValid)
            {
                return Coherance2(cp3, cp2);
            }

            //si un seul capteur est valide
            if (cp1.IsValid && !cp2.IsValid && !cp3.IsValid)
            {
                return Coherance1(cp1);
            }

            if (!cp1.IsValid && cp2.IsValid && !cp3.IsValid)
            {
                return Coherance1(cp2);
            }
            if (!cp1.IsValid && !cp2.IsValid && cp3.IsValid)
            {
                return Coherance1(cp3);
            }



            //par défaut
            return new Capteur (0, false);
        }

        private static Capteur Coherance2(Capteur cp1, Capteur cp2)
        {
            if (cp1.Valeur >= 1024 || cp1.Valeur < 0)
            {
                return Coherance1(cp2);
            }
            
            if (cp2.Valeur >= 1024 || cp2.Valeur < 0)
            {
                return Coherance1(cp1);
            }
            //if (Math.Abs(cp1.Valeur - cp2.Valeur) <= 5 || (cp1.Valeur - cp2.Valeur) >= -5)
            if (Math.Abs(cp1.Valeur - cp2.Valeur) <= 5)
            {
               
                    if (cp1.EstCoherant() && cp2.EstCoherant())
                    {
                        int moyenne = (cp2.Valeur + cp1.Valeur) / 2;
                        return new Capteur(moyenne, true);
                    }
                
            }

            return new Capteur(0, false);
        }

        private static Capteur Coherance1(Capteur cp)
        {
            if (cp.Valeur <= 950 && cp.Valeur >= 70)
            {
                return new Capteur(cp.Valeur, true);
            }

            return new Capteur(0, false);
        }

    }
}
